import { IRequestPerson } from '../../interfaces/person-request.interface';

export class Person {
  _personRequest: IRequestPerson;
  _defaultIdentifier: number;
  _defaultMarginDuration: number;
  identifier: number;
  marginDurations: Array<number>;

  constructor(
    personRequest: IRequestPerson,
    defaultIdentifier: number,
    defaultMarginDuration: number,
  ) {
    this._personRequest = personRequest;
    this._defaultIdentifier = defaultIdentifier;
    this._defaultMarginDuration = defaultMarginDuration;
  }

  init = (): void => {
    this.setIdentifier(
      this._personRequest.identifier ?? this._defaultIdentifier,
    );
    this.setMarginDurations([
      this._defaultMarginDuration,
      this._defaultMarginDuration,
      this._defaultMarginDuration,
      this._defaultMarginDuration,
      this._defaultMarginDuration,
      this._defaultMarginDuration,
      this._defaultMarginDuration,
    ]);
  };

  setIdentifier = (identifier: number): void => {
    this.identifier = identifier;
  };

  setMarginDurations = (marginDurations: Array<number>): void => {
    this.marginDurations = marginDurations;
  };
}
