import { MatchQuery } from 'src/modules/matcher/queries/match.query';
import { Processor } from '../processor/processor.abstract';
import { Candidate } from '../candidate';
import { Selector } from '../selector/selector.abstract';

export abstract class AlgorithmFactory {
  _matchQuery: MatchQuery;
  _candidates: Array<Candidate>;

  constructor(matchQuery: MatchQuery) {
    this._matchQuery = matchQuery;
    this._candidates = [];
  }

  abstract createSelector(): Selector;
  abstract createProcessors(): Array<Processor>;
}
